//
// MySQL_db.h
//
// SQL implementation, written by Zoran Constantinescu <zoran@idi.ntnu.no>
//
#ifndef _MySQL_db_h_
#define _MySQL_db_h_

#include "SQL_db.h"
#include <mysql.h>

class MySQL_db : public SQL_db
{
  protected:
    MySQL_db();
  public:
    ~MySQL_db();

    static MySQL_db	*getDatabaseInstance();
	
  protected:
    virtual int	    Connect (char *host, char *db, char *user, char *pswd);
    virtual int	    Disconnect ();

    virtual int     ExecQuery (String &sQuery);
    virtual int     GetInsertID ();
    virtual int     StoreResult ();
    virtual void    FreeResult (int result);
    virtual int     NumRows (int result);
    virtual char  **FetchRow (int result); 

    virtual char   *Error ();
    virtual void    Lock (String &sTable);
    virtual void    UnLock ();

    virtual void    QuoteString (String &s);

  private:
    static int   isConnect;
    static MYSQL mysql;

    MYSQL_RES *result;
    MYSQL_ROW row;
};

#endif


