#!/usr/local/bin/perl

# connection to MySQL server
$host= shift || "";
$user="root";
$pswd="q";
$db="zlsearch";

# which table to create
$c_URLS=1; 
$c_URLINFO=1;
$c_WORDS=1;
$c_LINKS=1;
$c_TMPLINKS=1;
$c_SERVERS=1;
$c_EMAILS=1;
$c_SEARCH=1;

use Mysql;
$|= 1;				# Autoflush

print "# Connecting to database $db...\n";

$dbh = Mysql->Connect($host, $db, $user, $pswd) || die "Can't connect: $Mysql::db_errstr\n";
$dbh->SelectDB($db) || die "Can't use database $db: $Mysql::db_errstr\n";

print "# Connection OK.\n";

#**********************************************************************
# URLS
#**********************************************************************
$table="URLS";
if ($c_URLS eq 1)
{
print "Creating table $table\n";
($dbh->Query("\
CREATE TABLE $table (
  DOC_ID	int UNSIGNED NOT NULL auto_increment,
  DOC_URL	char(232) NOT NULL,
  DOC_STATUS	smallint UNSIGNED NOT NULL,
  DOC_LANG	char(2) NOT NULL DEFAULT '??',
  DOC_TACCESS	datetime,
  DOC_HASH	int UNSIGNED,
  DOC_SERVER_ID	int UNSIGNED NOT NULL,
  PRIMARY KEY (DOC_ID),
  UNIQUE (DOC_URL(127)),
  KEY (DOC_STATUS),
  KEY (DOC_LANG),
  KEY (DOC_SERVER_ID)
)")) or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (DOC_URL, DOC_STATUS, DOC_LANG, DOC_TACCESS)\
  values ('http://kitt/zoran', 1, 'RO', '1998-08-20 15:20:19')") 
or die $Mysql::db_errstr;
} 


#**********************************************************************
# URLINFO
#**********************************************************************
$table="URLINFO";
if ($c_URLINFO eq 1)
{
print "Creating table $table\n";
($dbh->Query("\
CREATE TABLE $table (
  DOC_ID	int UNSIGNED NOT NULL,
  DOC_TMODIF	datetime,
  DOC_TITLE	text NOT NULL,
  DOC_TEXT	mediumtext NOT NULL,
  DOC_REFS	text NOT NULL,
  DOC_SIZE	mediumint UNSIGNED,
  DOC_LINKS	smallint UNSIGNED,
  DOC_ANCHORS	smallint UNSIGNED,
  DOC_HOPCOUNT	smallint UNSIGNED,
  PRIMARY KEY (DOC_ID)
)")) or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (DOC_ID, DOC_TITLE, DOC_SIZE)\
  values (1, 'Zoran home page', 715)") 
or die $Mysql::db_errstr;
}


#**********************************************************************
# WORDS
#**********************************************************************
$table="WORDS";
if ($c_WORDS eq 1)
{
print "Creating table $table\n";
($dbh->Query("\
CREATE TABLE $table (
  WORD_ID	int UNSIGNED NOT NULL auto_increment,
  WORD_TXT	char(30) NOT NULL,
  WORD_ROOT_ID	int UNSIGNED NOT NULL,
  WORD_ROOT_TXT	char(30) NOT NULL,
  WORD_LANG	char(2),
  WORD_STATUS	smallint,
  PRIMARY KEY (WORD_ID),
  UNIQUE (WORD_TXT),
  KEY (WORD_ROOT_ID),
  KEY (WORD_ROOT_TXT)
)"))  or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (WORD_TXT, WORD_ROOT_TXT, WORD_LANG)\
  values ('abandona', '', 'RO')") 
or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (WORD_TXT, WORD_ROOT_TXT, WORD_LANG)\
  values ('abandonez', 'abandona', 'RO')") 
or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (WORD_TXT, WORD_ROOT_TXT, WORD_LANG)\
  values ('abandonezi', 'abandona', 'RO')") 
or die $Mysql::db_errstr;
} 


#**********************************************************************
# LINKS
#**********************************************************************
$table="LINKS";
if ($c_LINKS eq 1)
{
print "Creating table $table\n";
($dbh->Query("\
CREATE TABLE $table (
  WORD_ID	int UNSIGNED NOT NULL,
  WORD_ROOT_ID	int UNSIGNED NOT NULL,
  DOC_ID	int UNSIGNED NOT NULL,
  COUNT		smallint UNSIGNED,
  WEIGHT	mediumint UNSIGNED,
  POSITION	mediumint UNSIGNED,
  ANCHOR	smallint UNSIGNED,
  KEY (WORD_ID),
  KEY (WORD_ROOT_ID),
  KEY (DOC_ID)
)"))  or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (WORD_ID, COUNT, WEIGHT)\
  values (1, 4, 100)") 
or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (WORD_ID, COUNT, WEIGHT)\
  values (2, 7, 230)") 
or die $Mysql::db_errstr;
}


#**********************************************************************
# TMPLINKS
#**********************************************************************
$table="TMPLINKS";
if ($c_TMPLINKS eq 1)
{
print "Creating table $table\n";
($dbh->Query("\
CREATE TABLE $table (
  WORD_ID	int UNSIGNED,
  WORD_ROOT_ID	int UNSIGNED,
  DOC_ID	int UNSIGNED,
  COUNT		smallint UNSIGNED,
  WEIGHT	mediumint UNSIGNED,
  POSITION	mediumint UNSIGNED,
  ANCHOR	smallint UNSIGNED
)"))  or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (WORD_ID, COUNT, WEIGHT)\
  values (1, 4, 100)") 
or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (WORD_ID, COUNT, WEIGHT)\
  values (2, 7, 230)") 
or die $Mysql::db_errstr;
}


#**********************************************************************
# SERVERS
#**********************************************************************
$table="SERVERS";
if ($c_SERVERS eq 1)
{
print "Creating table $table\n";
($dbh->Query("\
CREATE TABLE $table (
  SERVER_ID	int UNSIGNED NOT NULL auto_increment,
  SERVER_ADDR	varchar(80) NOT NULL,
  SERVER_STATUS	int UNSIGNED NOT NULL,
  SERVER_TYPE   varchar(120),
  PRIMARY KEY (SERVER_ID),
  UNIQUE (SERVER_ADDR),
  KEY (SERVER_STATUS)
)"))  or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (SERVER_ADDR)\
  values ('http://kitt.zealsoft.ro')") 
or die $Mysql::db_errstr;
}


#**********************************************************************
# EMAILS
#**********************************************************************
$table="EMAILS";
if ($c_EMAILS eq 1)
{
print "Creating table $table\n";
($dbh->Query("\
CREATE TABLE $table (
  EMAIL_ADDR	varchar(80) NOT NULL,
  DOC_ID	int UNSIGNED NOT NULL,
  PRIMARY KEY (EMAIL_ADDR),
  KEY (DOC_ID)
)"))  or die $Mysql::db_errstr;

print "Inserting 1 records into $table\n";
$dbh->Query("insert into $table 
  (EMAIL_ADDR)\
  values ('zoran\@zealsoft.ro')") 
or die $Mysql::db_errstr;
}


#**********************************************************************
# SEARCH
#**********************************************************************
$table="SEARCH";
if ($c_SEARCH eq 1)
{
print "Creating table $table\n";
($dbh->Query("\
CREATE TABLE $table (
  SEARCH_ID  		int UNSIGNED NOT NULL auto_increment,
  SEARCH_DATE		datetime,
  SEARCH_WORDS		varchar(80),
  SEARCH_RESULT		smallint UNSIGNED,
  SEARCH_SECS		double(10,3),
  REMOTE_HOST		varchar(80),
  REMOTE_ADDR		char(15),
  HTTP_USER_AGENT	varchar(80),
  HTTP_FROM      	varchar(80),
  PRIMARY KEY (SEARCH_ID)
)"))  or die $Mysql::db_errstr;
}


if (0) 
{
print "# Testing records...\n";
$table="Answers";
$sth=$dbh->Query("select * from $table");

for ($i=0 ; $i < $sth->numrows ; $i++)
{
  @row = $sth->FetchRow();
  print $row[0], " ", $row[1], " ", $row[2], "\n";
}
print "# Test ok.\n";
}

exit 0;

